IUnknown struct
	QueryInterface			dword ?
	Addref					dword ?
	Release					dword ?
IUnknown ends

IDispatch struct
	pIUnknown				IUnknown <>
	GetTypeInfoCount		dword ?
	GetTypeInfo				dword ?
	GetIDsOfNames			dword ?
	_Invoke					dword ?
IDispatch ends

IClassFactory struct
	pIUnknown				IUnknown <>
	_CreateInstance			dword ?
	LockServer				dword ?
IClassFactory ends
ITypeInfo struct
	QueryInterface		dword ? 
	AddRef				dword ? 
	Release				dword ? 
	GetTypeAttr			dword ? 
	GetTypeComp			dword ? 
	GetFuncDesc			dword ? 
	GetVarDesc			dword ? 
	GetNames			dword ? 
 	GetRefTypeOfImplType	dword ?
	GetImplTypeFlags	dword ?
	GetIDsOfNames		dword ?
	oleInvoke			dword ?
	GetDocumentation	dword ?
	GetDllEntry			dword ?
	GetRefTypeInfo		dword ?
	AddressOfMember		dword ?
	oleCreateInstance	dword ?
	GetMops				dword ?
	GetContainingTypeLib	dword ?
	ReleaseTypeAttr		dword ?
	ReleaseFuncDesc		dword ?
	ReleaseVarDesc		dword ?
ITypeInfo ends

TYPEDESC struct dword 
	union
		lptdesc				dword ? 
		lpadesc				dword ? 
		hreftype			dword ? 
	ends
	vt						word ?
TYPEDESC ends

IDLDESC struct dword 
	dwReserved			dword ?			
	wIDLFlags			word ?			
IDLDESC ends

PARAMDESC struct dword 
	pPARAMDescEx		dword ?			
	wPARAMFlags			word ?			
PARAMDESC ends

ELEMDESC struct
	tdesc				TYPEDESC <>		
	union
        idldesc			IDLDESC  <>		
        paramdesc		PARAMDESC <>	
    ends
ELEMDESC ends

TYPEATTR struct dword
	guid	    		GUID <>			
	lcid				dword ?	 		
	dwReserved			dword ?			
	memidConstructor	dword ? 		
	memidDestructor	    dword ? 		
	lpstrSchema			dword ? 		
	cbSizeInstance		dword ? 		
	typekind			dword ? 		
 	cFuncs				word ?			
	cVars				word ?			
	cImplTypes			word ?			
	cbSizeVft			word ?			
	cbAlignment			word ?			
										
	wTypeFlags			word ?			
	wMajorVerNum		word ?			
	wMinorVerNum		word ?			
	tdescAlias	    	TYPEDESC <>		
	idldescType			IDLDESC <>		

TYPEATTR ends

FUNCDESC struct dword
	memid				dword ?			
	lprgscode			dword ?			
	lprgelemdescParam	dword ?			
	funckind			dword ?			
    invkind				dword ?			
    callconv			dword ?			
	cParams				word ?			
	cParamsOpt			word ?			
	oVft				word ?			
	cScodes				word ?			
	elemdescFunc		ELEMDESC <>		
	wFuncFlags			word ?			
FUNCDESC ends
                                                                  
DISPPARAMS struct                                                         
	rgvarg					dword ? 
	rgdispidNamedArgs		dword ? 
	cArgs					dword ? 
	cNamedArgs				dword ? 
DISPPARAMS ends

VARIANT struct dword
    vt              	word ? 	
    wReserved1      	word ? 	
    wReserved2      	word ? 	
    wReserved3      	word ? 	
    Union
		lVal         	sdword ?
		bVal         	byte ?  
		iVal         	sword ? 
		fltVal       	real4 ? 
		dblVal       	real8 ? 
		boolVal      	word ?  
		scode        	dword ? 
		cyVal        	qword ? 
		date         	qword ? 
		bstrVal      	dword ? 
		punkVal      	dword ? 
		pdispVal     	dword ? 
		parray       	dword ? 
		pbVal        	dword ? 
		piVal        	dword ? 
		plVal        	dword ? 
		pfltVal      	dword ? 
		pdblVal      	dword ? 
		pboolVal     	dword ? 
		pscode       	dword ? 
		pcyVal       	dword ? 
		pdate        	dword ? 
		pbstrVal     	dword ? 
		ppunkVal     	dword ? 
		ppdispVal    	dword ? 
		pparray      	dword ? 
		pvarVal      	dword ? 
		byref        	dword ? 
		cVal         	sbyte ? 
		uiVal        	word ?  
		ulVal        	dword ? 
		intVal       	sword ? 
		uintVal      	word ?  
		pdecVal      	dword ? 
		pcVal        	dword ? 
		puiVal       	dword ? 
		pulVal       	dword ? 
		pintVal      	dword ?	
		puintVal     	dword ?	
    ends                                                                  
VARIANT ends	                                                          

Create_Object     	            	PROTO	:dword,:dword
Get_Object       	             	PROTO	:dword,:dword
Release_Object	                	PROTO	:dword
Set_Interface						PROTO	:dword,:dword,:dword

;Return **Object
Set_Object	                     	PROTO c	:dword,:dword,:dword,:dword,:dword,:vararg
;Return *Variant
Set_Object2	                     	PROTO c	:dword,:dword,:dword,:dword,:dword,:vararg

;Return Value
RunMethod                       	PROTO c	:dword,:dword,:dword,:dword,:dword,:vararg
;Return *Variant
RunMethod2                       	PROTO c	:dword,:dword,:dword,:dword,:dword,:vararg

BSTR macro args:vararg
	LOCAL PP,quot,c$,parseLen,P$,Esc,sizeLocal,sizeTotal,iArg,nArg,cDest$,_Label
	LOCAL sym

	Esc       = 0
	QuotState = 0
	sizeLocal = 0
	sizeTotal = 0
	nArg      = 0
	iArg      = 0

	FOR arg$,<&args>
		IFNB <&arg$>
			sizeLocal = 0
			iArg INSTR 1,<&arg$>,<!">
			Esc  INSTR 1,<&arg$>,<!'>
			IF (iArg  NE 0) OR (Esc NE 0)
				P$ textequ <&arg$>
				Esc = 0 
				quot SUBSTR P$,1,1
				ifidn quot,<">
				elseifidn quot,<'>
				else
				   .err <invalid string>   
				endif
				cDest$ textequ <>
				parseLen SIZESTR P$
				PP=1
				REPEAT parseLen
					c$ SUBSTR P$, PP, 1
					ifdif c$,quot
						if Esc eq 0
							ifidn c$,<\>
								sizeLocal = sizeLocal - 2
								Esc = 1
							else
								cDest$ CATSTR cDest$,<,>,quot,c$,quot
							endif
						else
							ifidn c$,<n>
								cDest$ CATSTR cDest$,<,13,10>
								sizeLocal = sizeLocal + 2
							elseifidn c$,<t>
								cDest$ CATSTR cDest$,<,9>
							elseifidn c$,<0>
								cDest$ CATSTR cDest$,<,0>
							elseifidn c$,<a>					; '('
								cDest$ CATSTR cDest$,<,028h>
							elseifidn c$,<b>					; ')' 
								cDest$ CATSTR cDest$,<,029h>
							elseifidn c$,<l>					; '<'
								cDest$ CATSTR cDest$,<,03ch>
							elseifidn c$,<r>					; '>'
								cDest$ CATSTR cDest$,<,03eh>
							elseifidn c$,<x>					; '!'
								cDest$ CATSTR cDest$,<,021h>
							elseifidn c$,<q>					; "
								cDest$ CATSTR cDest$,<,022h>
							elseifidn c$,<s>					; '
								cDest$ CATSTR cDest$,<,027h>
							elseifidn c$, <\>
								cDest$ CATSTR cDest$,<,>,quot,c$,quot
							else
								.err <invalid escape sequence>
							endif
							Esc = 0
						endif	
						sizeLocal = sizeLocal + 2
					endif
					
					IF (PP MOD 32) EQ 0
						cDest$ SUBSTR cDest$,2		
						@CatStr(<wData_Line_>,%(nArg)) TEXTEQU cDest$
						cDest$ TEXTEQU <>
						nArg = nArg + 1
						sizeTotal = sizeTotal + sizeLocal
						sizeLocal = 0
					ENDIF
					PP=PP+1
				ENDM
				parseLen SIZESTR cDest$
				if parseLen GT 1					
				   ifidn @SubStr(<%cDest$>,1,1),<,> 
						cDest$ SUBSTR cDest$,2		
				   endif							
				endif								
				@CatStr(<wData_Line_>,%(nArg)) TEXTEQU cDest$
			ELSE
				@CatStr(<wData_Line_>,%(nArg)) TEXTEQU <&arg$>
				sizeLocal = sizeLocal + 2
			ENDIF		
			nArg = nArg + 1
			sizeTotal = sizeTotal + sizeLocal
		ENDIF
	ENDM
   	
  	_Label struct
  		db (sizeTotal+2) dup (?)	; +2 for zero terminator
  	_Label ends
  	
  	data segment
  		align 4
		;;Number of bytes in the following data string, terminator not include.
		dd SIZEOF _Label-2
		sym label _Label		
  		iArg = 0
  		REPEAT nArg
			IFIDN @CatStr(<wData_Line_>,%(iArg)),<"">
			ELSEIFIDN @CatStr(<wData_Line_>,%(iArg)),<''>
			ELSEIFB @CatStr(<wData_Line_>,%(iArg))
  			ELSE
  				dw @CatStr(<wData_Line_>,%(iArg))
  			ENDIF
  			iArg = iArg + 1
  		ENDM
  		dw 0
  	data ends
  	
  	exitm <offset sym>
endm

WSTR macro args:vararg
	LOCAL PP,quot,c$,parseLen,P$,Esc,sizeLocal,sizeTotal,iArg,nArg,cDest$,_Label
	LOCAL sym

	Esc       = 0
	QuotState = 0
	sizeLocal = 0
	sizeTotal = 0
	nArg      = 0
	iArg      = 0

	FOR arg$,<&args>
		IFNB <&arg$>
			sizeLocal = 0
			iArg INSTR 1,<&arg$>,<!">
			Esc  INSTR 1,<&arg$>,<!'>
			IF (iArg  NE 0) OR (Esc NE 0)
				P$ textequ <&arg$>
				Esc = 0 
				quot SUBSTR P$,1,1
				ifidn quot,<">
				elseifidn quot,<'>
				else
				   .err <invalid string>   
				endif
				cDest$ textequ <>
				parseLen SIZESTR P$
				PP=1
				REPEAT parseLen
					c$ SUBSTR P$, PP, 1
					ifdif c$,quot
						if Esc eq 0
							ifidn c$,<\>
								sizeLocal = sizeLocal - 2
								Esc = 1
							else
								cDest$ CATSTR cDest$,<,>,quot,c$,quot
							endif
						else
							ifidn c$,<n>
								cDest$ CATSTR cDest$,<,13,10>
								sizeLocal = sizeLocal + 2
							elseifidn c$,<t>
								cDest$ CATSTR cDest$,<,9>
							elseifidn c$,<0>
								cDest$ CATSTR cDest$,<,0>
							elseifidn c$,<a>					; '('
								cDest$ CATSTR cDest$,<,028h>
							elseifidn c$,<b>					; ')' 
								cDest$ CATSTR cDest$,<,029h>
							elseifidn c$,<l>					; '<'
								cDest$ CATSTR cDest$,<,03ch>
							elseifidn c$,<r>					; '>'
								cDest$ CATSTR cDest$,<,03eh>
							elseifidn c$,<x>					; '!'
								cDest$ CATSTR cDest$,<,021h>
							elseifidn c$,<q>					; "
								cDest$ CATSTR cDest$,<,022h>
							elseifidn c$,<s>					; '
								cDest$ CATSTR cDest$,<,027h>
							elseifidn c$, <\>
								cDest$ CATSTR cDest$,<,>,quot,c$,quot
							else
								.err <invalid escape sequence>
							endif
							Esc = 0
						endif	
						sizeLocal = sizeLocal + 2
					endif
					
					IF (PP MOD 32) EQ 0
						cDest$ SUBSTR cDest$,2		
						@CatStr(<wData_Line_>,%(nArg)) TEXTEQU cDest$
						cDest$ TEXTEQU <>
						nArg = nArg + 1
						sizeTotal = sizeTotal + sizeLocal
						sizeLocal = 0
					ENDIF
					PP=PP+1
				ENDM
				parseLen SIZESTR cDest$
				if parseLen GT 1					
				   ifidn @SubStr(<%cDest$>,1,1),<,> 
						cDest$ SUBSTR cDest$,2		
				   endif							
				endif								
				@CatStr(<wData_Line_>,%(nArg)) TEXTEQU cDest$
			ELSE
				@CatStr(<wData_Line_>,%(nArg)) TEXTEQU <&arg$>
				sizeLocal = sizeLocal + 2
			ENDIF		
			nArg = nArg + 1
			sizeTotal = sizeTotal + sizeLocal
		ENDIF
	ENDM
   	
  	_Label struct
  		db (sizeTotal+2) dup (?)	; +2 for zero terminator
  	_Label ends
  	
  	data segment
		sym label _Label		
  		iArg = 0
  		REPEAT nArg
			IFIDN @CatStr(<wData_Line_>,%(iArg)),<"">
			ELSEIFIDN @CatStr(<wData_Line_>,%(iArg)),<''>
			ELSEIFB @CatStr(<wData_Line_>,%(iArg))
  			ELSE
  				dw @CatStr(<wData_Line_>,%(iArg))
  			ENDIF
  			iArg = iArg + 1
  		ENDM
  		dw 0
  	data ends
  	
  	exitm <offset sym>
endm

ASTR macro args:VARARG
	LOCAL sym
	data segment
		ifidni <args>,<>
			sym db 0
		else
			sym db args,0
		endif
	data ends
	exitm <offset sym>
endm


INVOKE_UNKNOWN                  equ 0 
INVOKE_FUNC                     equ 1 
INVOKE_PROPERTYGET              equ 2 
INVOKE_PROPERTYPUT              equ 4 
INVOKE_PROPERTYPUTREF           equ 8 
INVOKE_EVENTFUNC                equ 16
INVOKE_CONST                    equ 32

DISPATCH_METHOD                 equ 1 
DISPATCH_PROPERTYGET            equ 2 
DISPATCH_PROPERTYPUT            equ 4 
DISPATCH_PROPERTYPUTREF         equ 8 

DISPID_UNKNOWN 					equ -1
DISPID_VALUE 					equ 0
DISPID_PROPERTYPUT 				equ -3
DISPID_NEWENUM 					equ -4
DISPID_EVALUATE 				equ -5
DISPID_CONSTRUCTOR 				equ -6
DISPID_DESTRUCTOR 				equ -7
DISPID_COLLECT 					equ -8
